/*
 * Copyright (c) 2026 University of Insubria <https://www.uninsubria.it>
 *
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2.1 of the License, or (at
 * your option) any later version. All we ask is that proper credit is given
 * for our work, which includes - but is not limited to - adding the above
 * copyright notice to the beginning of your source code files, and to any
 * copyright notice that you may distribute with programs based on this work.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
 * License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation, Inc.
 * <https://fsf.org/>
 */

package qsardes.descriptor;

import java.util.Arrays;
import java.util.HashMap;
import qsardes.molecule.Molecule;
import qsardes.molecule.AbstractMoleculeBuilder;
import qsardes.util.UtilsCalc;
import java.util.List;
import java.util.Map;
import org.openscience.cdk.graph.matrix.TopologicalMatrix;

/**
 * Topological descriptors abstract class.
 *
 * @author Nicola Chirico
 */
public abstract class DescriptorTopological implements Descriptor
{
    protected DescriptorTopological()
    {
    }

    @Override
    public String toString()
    {
        return "Topological";
    }

    @Override
    public DescriptorType get_descriptor_type()
    {
        return DescriptorType.valueOf("DESCRIPTOR");
    }

    @Override
    public List<String> get_descriptor_names()
    {
        return Arrays.asList("topoRadius", "topoDiameter", "topoShape");
    }

    @Override
    public Map<String, String> get_descriptor_values(
            AbstractMoleculeBuilder mol_build)
    {
        prepare_descr_map();

        try {
            mol = new Molecule(mol_build);
            calculate_descr();
        } catch (Exception ex) {
            System.err.println(ex);
        }

        return descr_map;
    }

    private void prepare_descr_map()
    {
        final String NAN = String.valueOf(Double.NaN);

        get_descriptor_names().forEach(item -> descr_map.put(item, NAN));
    }

    private void calculate_descr()
    {
        int[][] topo_matr = TopologicalMatrix
                .getMatrix​(mol.get_atom_container());

        int[] ni = new int[topo_matr.length];

        var utils_calc = new UtilsCalc();

        for (int i = 0; i < topo_matr.length; i++) {
            ni[i] = utils_calc.get_max(topo_matr[i]);
        }

        int rad = utils_calc.get_min(ni);
        int dia = utils_calc.get_max(ni);

        descr_map.put("topoRadius", String.valueOf(rad));
        descr_map.put("topoDiameter", String.valueOf(dia));

        if (rad > 0) {
            descr_map.put("topoShape", String.valueOf(
                    ((double) dia - (double) rad) / (double) rad));
        }
    }

    private final Map<String, String> descr_map = new HashMap<>();

    private Molecule mol;
}
